//
//  StepGenTxViewController.swift
//  Cosmostation
//
//  Created by yongjoo on 08/04/2019.
//  Copyright © 2019 wannabit. All rights reserved.
//

import UIKit
import Alamofire
import GRPC
import NIO
import HDWalletKit
import SwiftKeychainWrapper

class StepGenTxViewController: UIPageViewController, UIPageViewControllerDelegate, UIPageViewControllerDataSource, UIScrollViewDelegate {
    
    fileprivate var currentIndex = 0
    var disableBounce = false
    
    var topVC: TransactionViewController!
    var mType: String?
    
    var mAccount: Account?
    var chainType: ChainType?
    var mBalances = Array<Balance>()
    
    var mToSendRecipientAddress:String?
    var mToSendAmount = Array<Coin>()
    
    var mTargetValidator_gRPC: Cosmos_Staking_V1beta1_Validator?
    var mToDelegateAmount: Coin?
    var mToUndelegateAmount:Coin?
    var mRewardAddress: String?
    var mRewardTargetValidators_gRPC = Array<Cosmos_Staking_V1beta1_Validator>()
    
    var mToReDelegateAmount: Coin?
    var mToReDelegateValidator_gRPC: Cosmos_Staking_V1beta1_Validator?
    var mToReDelegateValidators_gRPC = Array<Cosmos_Staking_V1beta1_Validator>()
    
    var mCurrentRewardAddress: String?
    var mToChangeRewardAddress: String?
    
    var mReinvestReward: Coin?
    
    var mMemo: String?
    var mFee: Fee?
    
    var mCollateral = Coin.init()
    var mPrincipal = Coin.init()
    var mPayment = Coin.init()
    var mSender: String?
    
    var currentPrice: NSDecimalNumber?
    var liquidationPrice: NSDecimalNumber?
    var riskRate: NSDecimalNumber?
    var beforeLiquidationPrice: NSDecimalNumber?
    var afterLiquidationPrice: NSDecimalNumber?
    var beforeRiskRate: NSDecimalNumber?
    var afterRiskRate: NSDecimalNumber?
    var totalDepositAmount: NSDecimalNumber?
    var totalLoanAmount: NSDecimalNumber?
    
    var mBnbToken: BnbToken?
    
    var mProposeId: String?
    var mProposalTitle: String?
    var mProposer: String?
    var mVoteOpinion: String?
    var mProposals = Array<MintscanProposalDetail>()
    
    var mCollateralParamType: String?
    var mCDenom: String?
    var mPDenom: String?
    var mMarketID: String?
    var mCollateralParam: CollateralParam?
    var mIncentiveKavaReceivable = NSDecimalNumber.zero
    var mIncentiveHardReceivable = NSDecimalNumber.zero
    var mHardMoneyMarketDenom: String?
    var mHardPoolCoins: Array<Coin>?
    var mIncentiveMultiplier: String?
    var mHardPoolCoin = Coin.init()
    var mKavaShareAmount = NSDecimalNumber.zero
    var mKavaCollateralParam: Kava_Cdp_V1beta1_CollateralParam?
    var mKavaSwapPool: Kava_Swap_V1beta1_PoolResponse?
    var mKavaSwapPoolDeposit: Kava_Swap_V1beta1_DepositResponse?
    
    
    var mHtlcDenom: String?
    var mHtlcToChain: ChainType?
    var mHtlcToAccount: Account?
    var mHtlcSendFee: Fee?
    var mHtlcClaimFee: Fee?
    var mKavaSwapParam2: KavaSwapParam2?
    var mKavaSwapSupply2: KavaSwapSupply2?
    
    
    var mSwapRemainCap: NSDecimalNumber = NSDecimalNumber.zero
    var mSwapMaxOnce: NSDecimalNumber = NSDecimalNumber.zero
    
    var mOkToStaking = Coin.init()
    var mOkToWithdraw = Coin.init()
    var mOkVoteValidators: Array<String> = Array<String>()
    
    var mStarnameDomain: String?
    var mStarnameAccount: String?
    var mStarnameTime: Int64?
    var mStarnameDomainType: String?
    var mStarnameResources_gRPC: Array<Starnamed_X_Starname_V1beta1_Resource> = Array<Starnamed_X_Starname_V1beta1_Resource>()
    
    var mToSendDenom: String?
    
    var mPoolId: String?
    var mSwapInDenom: String?
    var mSwapOutDenom: String?
    var mSwapInAmount: NSDecimalNumber?
    var mSwapOutAmount: NSDecimalNumber?
    var mPool: Osmosis_Gamm_Balancer_V1beta1_Pool?
    var mPoolCoin0: Coin?
    var mPoolCoin1: Coin?
    var mLPCoin: Coin?
    var mLockupDuration: Int64?
    var mLockups: Array<Osmosis_Lockup_PeriodLock>?
    
    
    var mSifPool: Sifnode_Clp_V1_Pool?
    var mSifMyAllUnitAmount: String?
    var mSifMyWithdrawUnitAmount: String?
    
    var mIBCSendDenom: String?
    var mIBCSendAmount: String?
    var mIBCRecipient: String?
    var mIBCSendRelayer: IbcPath?
    var mIBCSendPath: Path?
    var mCw20SendContract: String?
    
    var mNFTHash: String?
    var mNFTName: String?
    var mNFTDescription: String?
    var mNFTDenomId: String?
    var mNFTDenomName: String?
    var mNFTTokenId: String?
    var irisResponse: Irismod_Nft_QueryNFTResponse?
    var croResponse: Chainmain_Nft_V1_QueryNFTResponse?
    
    var mDesmosDtag: String?
    var mDesmosNickName: String?
    var mDesmosBio: String?
    var mDesmosCoverHash: String?
    var mDesmosProfileHash: String?
    var mDesmosToLinkChain: ChainType?
    var mDesmosToLinkAccountId: Int64!
    var mDesmosAirDropAmount: String?
    
    
    lazy var orderedViewControllers: [UIViewController] = {
        if (mType == TASK_TYPE_TRANSFER) {
            if (WUtils.isGRPC(chainType!)) {
                return [Transfer1ViewController(nibName: "Transfer1ViewController", bundle: nil),
                        Transfer2ViewController(nibName: "Transfer2ViewController", bundle: nil),
                        MemoViewController(nibName: "MemoViewController", bundle: nil),
                        FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                        Transfer5ViewController(nibName: "Transfer5ViewController", bundle: nil)]
            } else {
                return [Transfer1ViewController(nibName: "Transfer1ViewController", bundle: nil),
                        Transfer2ViewController(nibName: "Transfer2ViewController", bundle: nil),
                        MemoViewController(nibName: "MemoViewController", bundle: nil),
                        FeeLcdViewController(nibName: "FeeLcdViewController", bundle: nil),
                        Transfer5ViewController(nibName: "Transfer5ViewController", bundle: nil)]
            }
            
        } else if (mType == TASK_TYPE_DELEGATE) {
            return [Delegate1ViewController(nibName: "Delegate1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    Delegate4ViewController(nibName: "Delegate4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_UNDELEGATE) {
            return [Undelegate1ViewController(nibName: "Undelegate1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    Undelegate4ViewController(nibName: "Undelegate4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_REDELEGATE) {
            return [Redelegate1ViewController(nibName: "Redelegate1ViewController", bundle: nil),
                    Redelegate2ViewController(nibName: "Redelegate2ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    Redelegate5ViewController(nibName: "Redelegate5ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_CLAIM_STAKE_REWARD) {
            return [ClaimReward1ViewController(nibName: "ClaimReward1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    ClaimReward4ViewController(nibName: "ClaimReward4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_MODIFY_REWARD_ADDRESS) {
            return [RewardAddress1ViewController(nibName: "RewardAddress1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    RewardAddress4ViewController(nibName: "RewardAddress4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_REINVEST) {
            return [ReInvest1ViewController(nibName: "ReInvest1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    ReInvest4ViewController(nibName: "ReInvest4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_VOTE) {
            return [Vote1ViewController(nibName: "Vote1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    Vote4ViewController(nibName: "Vote4ViewController", bundle: nil)]
        }
        
        //KAVA
        else if (mType == TASK_TYPE_KAVA_CDP_CREATE) {
            return [CdpCreate1ViewController(nibName: "CdpCreate1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    CdpCreate4ViewController(nibName: "CdpCreate4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_CDP_DEPOSIT) {
            return [CdpDeposit1ViewController(nibName: "CdpDeposit1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    CdpDeposit4ViewController(nibName: "CdpDeposit4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_CDP_WITHDRAW) {
            return [CdpWithdraw1ViewController(nibName: "CdpWithdraw1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    CdpWithdraw4ViewController(nibName: "CdpWithdraw4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_CDP_DRAWDEBT) {
            return [CdpDrawDebt1ViewController(nibName: "CdpDrawDebt1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    CdpDrawDebt4ViewController(nibName: "CdpDrawDebt4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_CDP_REPAY) {
            return [CdpDrawRepay1ViewController(nibName: "CdpDrawRepay1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    CdpDrawRepay4ViewController(nibName: "CdpDrawRepay4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_HARD_DEPOSIT) {
            return [HardPoolDeposit0ViewController(nibName: "HardPoolDeposit0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    HardPoolDeposit3ViewController(nibName: "HardPoolDeposit3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_HARD_WITHDRAW) {
            return [HardPoolWithdraw0ViewController(nibName: "HardPoolWithdraw0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    HardPoolWithdraw3ViewController(nibName: "HardPoolWithdraw3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_HARD_BORROW) {
            return [HardPoolBorrow0ViewController(nibName: "HardPoolBorrow0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    HardPoolBorrow3ViewController(nibName: "HardPoolBorrow3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_HARD_REPAY) {
            return [HardPoolRepay0ViewController(nibName: "HardPoolRepay0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    HardPoolRepay3ViewController(nibName: "HardPoolRepay3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_SWAP_TOKEN) {
            return [KavaSwap0ViewController(nibName: "KavaSwap0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    KavaSwap3ViewController(nibName: "KavaSwap3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_KAVA_SWAP_DEPOSIT) {
            return [KavaSwapJoin0ViewController(nibName: "KavaSwapJoin0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    KavaSwapJoin3ViewController(nibName: "KavaSwapJoin3ViewController", bundle: nil)]

        } else if (mType == TASK_TYPE_KAVA_SWAP_WITHDRAW) {
            return [KavaSwapExit0ViewController(nibName: "KavaSwapExit0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    KavaSwapExit3ViewController(nibName: "KavaSwapExit3ViewController", bundle: nil)]

        } else if (mType == TASK_TYPE_KAVA_INCENTIVE_ALL) {
            return [KavaIncentiveClaim0ViewController(nibName: "KavaIncentiveClaim0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    KavaIncentiveClaim3ViewController(nibName: "KavaIncentiveClaim3ViewController", bundle: nil)]
        }
        
        //BEP3 Stranfer (KAVA, BINANCE)
        else if (mType == TASK_TYPE_HTLC_SWAP) {
            return [HtlcSend0ViewController(nibName: "HtlcSend0ViewController", bundle: nil),
                    HtlcSend1ViewController(nibName: "HtlcSend1ViewController", bundle: nil),
                    HtlcSend2ViewController(nibName: "HtlcSend2ViewController", bundle: nil),
                    HtlcSend3ViewController(nibName: "HtlcSend3ViewController", bundle: nil)]
        }
        
        //OEC
        else if (mType == TASK_TYPE_OK_DEPOSIT) {
            return [OkDeposit1ViewController(nibName: "OkDeposit1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeLcdViewController(nibName: "FeeLcdViewController", bundle: nil),
                    OkDeposit4ViewController(nibName: "OkDeposit4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_OK_WITHDRAW) {
            return [OkWithdraw1ViewController(nibName: "OkWithdraw1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeLcdViewController(nibName: "FeeLcdViewController", bundle: nil),
                    OkWithdraw4ViewController(nibName: "OkWithdraw4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_OK_DIRECT_VOTE) {
            return [OkVote1ViewController(nibName: "OkVote1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeLcdViewController(nibName: "FeeLcdViewController", bundle: nil),
                    OkVote4ViewController(nibName: "OkVote4ViewController", bundle: nil)]
        }
        
        //STARTNAME
        else if (mType == TASK_TYPE_STARNAME_REGISTER_DOMAIN) {
            return [RegisterDomain0ViewController(nibName: "RegisterDomain0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    RegisterDomain3ViewController(nibName: "RegisterDomain3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_STARNAME_REGISTER_ACCOUNT) {
            return [RegisterAccount0ViewController(nibName: "RegisterAccount0ViewController", bundle: nil),
                    RegisterAccount1ViewController(nibName: "RegisterAccount1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    RegisterAccount4ViewController(nibName: "RegisterAccount4ViewController", bundle: nil)]

        } else if (mType == TASK_TYPE_STARNAME_DELETE_DOMAIN || mType == TASK_TYPE_STARNAME_DELETE_ACCOUNT) {
            return [DeleteStarname0ViewController(nibName: "DeleteStarname0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    DeleteStarname3ViewController(nibName: "DeleteStarname3ViewController", bundle: nil)]

        } else if (mType == TASK_TYPE_STARNAME_RENEW_DOMAIN || mType == TASK_TYPE_STARNAME_RENEW_ACCOUNT) {
            return [RenewStarname0ViewController(nibName: "RenewStarname0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    RenewStarname3ViewController(nibName: "RenewStarname3ViewController", bundle: nil)]

        } else if (mType == TASK_TYPE_STARNAME_REPLACE_RESOURCE) {
            return [ReplaceResource0ViewController(nibName: "ReplaceResource0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    ReplaceResource3ViewController(nibName: "ReplaceResource3ViewController", bundle: nil)]
        }
        
        //OSMOSIS
        else if (mType == TASK_TYPE_OSMOSIS_SWAP) {
            return [Swap0ViewController(nibName: "Swap0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    Swap3ViewController(nibName: "Swap3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_OSMOSIS_JOIN_POOL) {
            return [JoinPool0ViewController(nibName: "JoinPool0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    JoinPool3ViewController(nibName: "JoinPool3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_OSMOSIS_EXIT_POOL) {
            return [ExitPool0ViewController(nibName: "ExitPool0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    ExitPool3ViewController(nibName: "ExitPool3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_OSMOSIS_LOCK) {
            return [StartLock0ViewController(nibName: "StartLock0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    StartLock3ViewController(nibName: "StartLock3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_OSMOSIS_BEGIN_UNLCOK) {
            return [StartUnbonding0ViewController(nibName: "StartUnbonding0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    StartUnbonding3ViewController(nibName: "StartUnbonding3ViewController", bundle: nil)]
        }
        
        //SIF
        else if (mType == TASK_TYPE_SIF_ADD_LP) {
            return [SifJoinPool0ViewController(nibName: "SifJoinPool0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    SifJoinPool3ViewController(nibName: "SifJoinPool3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_SIF_REMOVE_LP) {
            return [SifExitPool0ViewController(nibName: "SifExitPool0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    SifExitPool3ViewController(nibName: "SifExitPool3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_SIF_SWAP_CION) {
            return [SifSwap0ViewController(nibName: "SifSwap0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    SifSwap3ViewController(nibName: "SifSwap3ViewController", bundle: nil)]
        }
        
        //DESMOS
        else if (mType == TASK_TYPE_DESMOS_GEN_PROFILE) {
            return [GenProfile0ViewController(nibName: "GenProfile0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    GenProfile3ViewController(nibName: "GenProfile3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_DESMOS_LINK_CHAIN_ACCOUNT) {
            return [LinkChainAccount0ViewController(nibName: "LinkChainAccount0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    LinkChainAccount3ViewController(nibName: "LinkChainAccount3ViewController", bundle: nil)]
        }
        
        //NFT
        else if (mType == TASK_TYPE_NFT_ISSUE) {
            return [GenNFT0ViewController(nibName: "GenNFT0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    GenNFT3ViewController(nibName: "GenNFT3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_NFT_SEND) {
            return [SendNFT0ViewController(nibName: "SendNFT0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    SendNFT3ViewController(nibName: "SendNFT3ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_NFT_ISSUE_DENOM) {
            return [GenDenom0ViewController(nibName: "GenDenom0ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    GenDenom3ViewController(nibName: "GenDenom3ViewController", bundle: nil)]
        }
        
        //COMMON
        else if (mType == TASK_TYPE_IBC_TRANSFER) {
            return [IBCSend0ViewController(nibName: "IBCSend0ViewController", bundle: nil),
                    IBCSend1ViewController(nibName: "IBCSend1ViewController", bundle: nil),
                    IBCSend2ViewController(nibName: "IBCSend2ViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    IBCSend4ViewController(nibName: "IBCSend4ViewController", bundle: nil)]
            
        } else if (mType == TASK_TYPE_IBC_CW20_TRANSFER) {
            return [SendContract0ViewController(nibName: "SendContract0ViewController", bundle: nil),
                    SendContract1ViewController(nibName: "SendContract1ViewController", bundle: nil),
                    MemoViewController(nibName: "MemoViewController", bundle: nil),
                    FeeGrpcViewController(nibName: "FeeGrpcViewController", bundle: nil),
                    SendContract4ViewController(nibName: "SendContract4ViewController", bundle: nil)]
        }
        
        else {
            return[]
        }
    }()
    
    required init?(coder aDecoder: NSCoder) {
        super.init(transitionStyle: .scroll, navigationOrientation: .horizontal, options: nil)
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
//        if #available(iOS 13.0, *) { overrideUserInterfaceStyle = BaseData.instance.getThemeType() }
        
        mAccount        = BaseData.instance.selectAccountById(id: BaseData.instance.getRecentAccountId())
        mBalances       = mAccount!.account_balances
        chainType       = ChainFactory.getChainType(mAccount!.account_base_chain)
        mBnbToken       = WUtils.getBnbToken(mToSendDenom)
        
        self.getKey()
        
        if (mType == TASK_TYPE_REDELEGATE) {
            self.onFetchBondedValidators(0)
            
        } else if (mType == TASK_TYPE_OK_DIRECT_VOTE) {
            if let votedVals = BaseData.instance.mOkStaking?.validator_address {
                self.mOkVoteValidators = votedVals
            } else {
                self.mOkVoteValidators = Array<String>()
            }
        }
            
        self.dataSource = self
        self.delegate = self
        if let firstViewController = orderedViewControllers.first {
            setViewControllers([firstViewController], direction: .forward, animated: true, completion: nil)
        }
        
        for view in self.view.subviews {
            if let subView = view as? UIScrollView {
                subView.delegate = self
                subView.isScrollEnabled = false
                subView.bouncesZoom = false
            }
        }
        disableBounce = true
    }
    
    func newVc(viewController: String) ->UIViewController {
        return UIStoryboard(name: "GenTx", bundle: nil).instantiateViewController(withIdentifier: viewController)
    }

    func onBeforePage() {
        disableBounce = false
        if (currentIndex == 0) {
            self.navigationController?.popViewController(animated: true)
        } else {
            setViewControllers([orderedViewControllers[currentIndex - 1]], direction: .reverse, animated: true, completion: { (finished) -> Void in
                self.currentIndex = self.currentIndex - 1
                let value:[String: Int] = ["step": self.currentIndex ]
                NotificationCenter.default.post(name: Notification.Name("stepChanged"), object: nil, userInfo: value)
                let currentVC = self.orderedViewControllers[self.currentIndex] as! BaseViewController
                currentVC.enableUserInteraction()
                self.disableBounce = true
            })
        }
        
    }
    
    func onNextPage() {
        disableBounce = false
        if (mType == TASK_TYPE_TRANSFER || mType == TASK_TYPE_REDELEGATE || mType == TASK_TYPE_STARNAME_REGISTER_ACCOUNT ||
            mType == TASK_TYPE_IBC_TRANSFER || mType == TASK_TYPE_IBC_CW20_TRANSFER) {
            if (currentIndex > 3) { return }
        } else {
            if (currentIndex > 2) { return }
        }
        setViewControllers([orderedViewControllers[currentIndex + 1]], direction: .forward, animated: true, completion: { (finished) -> Void in
            self.currentIndex = self.currentIndex + 1
            let value:[String: Int] = ["step": self.currentIndex ]
            NotificationCenter.default.post(name: Notification.Name("stepChanged"), object: nil, userInfo: value)
            let currentVC = self.orderedViewControllers[self.currentIndex] as! BaseViewController
            currentVC.enableUserInteraction()
            self.disableBounce = true
        })
    }
    
    func pageViewController(_ pageViewController: UIPageViewController, viewControllerBefore viewController: UIViewController) -> UIViewController? {
        return nil
    }
    
    func pageViewController(_ pageViewController: UIPageViewController, viewControllerAfter viewController: UIViewController) -> UIViewController? {
        return nil
    }
    
    func pageViewController(_ pageViewController: UIPageViewController, didFinishAnimating finished: Bool, previousViewControllers: [UIViewController], transitionCompleted completed: Bool) {
        if(!completed) {
            
        } else {
            if let currentViewController = pageViewController.viewControllers?.first,
                let index = orderedViewControllers.index(of: currentViewController) {
                currentIndex = index
            }
            let value:[String: Int] = ["step": currentIndex]
            NotificationCenter.default.post(name: Notification.Name("stepChanged"), object: nil, userInfo: value)
        }
    }
    
    func scrollViewDidScroll(_ scrollView: UIScrollView) {
        if(disableBounce) {
            scrollView.contentOffset = CGPoint(x: scrollView.bounds.size.width, y: 0);
        }
    }
    
    func scrollViewWillEndDragging(_ scrollView: UIScrollView, withVelocity velocity: CGPoint, targetContentOffset: UnsafeMutablePointer<CGPoint>) {
        if(disableBounce) {
            targetContentOffset.pointee = CGPoint(x: scrollView.bounds.size.width, y: 0);
        }
    }
    
    func onFetchBondedValidators(_ offset:Int) {
        DispatchQueue.global().async {
            let group = MultiThreadedEventLoopGroup(numberOfThreads: 1)
            defer { try! group.syncShutdownGracefully() }
            
            let channel = BaseNetWork.getConnection(self.chainType!, group)!
            defer { try! channel.close().wait() }
            
            let page = Cosmos_Base_Query_V1beta1_PageRequest.with {
                $0.limit = 300
            }
            let req = Cosmos_Staking_V1beta1_QueryValidatorsRequest.with {
                $0.pagination = page
                $0.status = "BOND_STATUS_BONDED"
            }
            do {
                let response = try Cosmos_Staking_V1beta1_QueryClient(channel: channel).validators(req).response.wait()
                response.validators.forEach { validator in
                    if (validator.operatorAddress != self.mTargetValidator_gRPC?.operatorAddress) {
                        self.mToReDelegateValidators_gRPC.append(validator)
                    }
                }
            } catch {
                print("onFetchgRPCBondedValidators failed: \(error)")
            }
            
            DispatchQueue.main.async(execute: {
                self.sortByPower()
            });
        }
        
    }
    
    func sortByPower() {
        mToReDelegateValidators_gRPC.sort{
            if ($0.description_p.moniker == "Cosmostation") { return true }
            if ($1.description_p.moniker == "Cosmostation") { return false }
            if ($0.jailed && !$1.jailed) { return false }
            if (!$0.jailed && $1.jailed) { return true }
            return Double($0.tokens)! > Double($1.tokens)!
        }
    }
    
    
    var privateKey: Data?
    var publicKey: Data?
    func getKey() {
        DispatchQueue.global().async {
            if (BaseData.instance.getUsingEnginerMode()) {
                if (self.mAccount?.account_from_mnemonic == true) {
                    if let words = KeychainWrapper.standard.string(forKey: self.mAccount!.account_uuid.sha1())?.trimmingCharacters(in: .whitespacesAndNewlines).components(separatedBy: " ") {
                        self.privateKey = KeyFac.getPrivateRaw(words, self.mAccount!)
                        self.publicKey = KeyFac.getPublicFromPrivateKey(self.privateKey!)
                    }
                    
                } else {
                    if let key = KeychainWrapper.standard.string(forKey: self.mAccount!.getPrivateKeySha1()) {
                        self.privateKey = KeyFac.getPrivateFromString(key)
                        self.publicKey = KeyFac.getPublicFromPrivateKey(self.privateKey!)
                    }
                }
                
            } else {
                //Speed up for get privatekey with non-enginerMode
                if let key = KeychainWrapper.standard.string(forKey: self.mAccount!.getPrivateKeySha1()) {
                    self.privateKey = KeyFac.getPrivateFromString(key)
                    self.publicKey = KeyFac.getPublicFromPrivateKey(self.privateKey!)
                    print("Private private ", self.privateKey!.hexEncodedString())
                    print("Private publicKey ", self.publicKey!.hexEncodedString())
                }
            }
        }
    }
}
