//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: cryptoorg/supply/v1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query defines the gRPC querier service.
///
/// Usage: instantiate `Chainmain_Supply_V1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Chainmain_Supply_V1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Chainmain_Supply_V1_QueryClientInterceptorFactoryProtocol? { get }

  func totalSupply(
    _ request: Chainmain_Supply_V1_SupplyRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Chainmain_Supply_V1_SupplyRequest, Chainmain_Supply_V1_SupplyResponse>

  func liquidSupply(
    _ request: Chainmain_Supply_V1_SupplyRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Chainmain_Supply_V1_SupplyRequest, Chainmain_Supply_V1_SupplyResponse>
}

extension Chainmain_Supply_V1_QueryClientProtocol {
  internal var serviceName: String {
    return "chainmain.supply.v1.Query"
  }

  /// TotalSupply queries the total supply of all coins.
  ///
  /// - Parameters:
  ///   - request: Request to send to TotalSupply.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func totalSupply(
    _ request: Chainmain_Supply_V1_SupplyRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Chainmain_Supply_V1_SupplyRequest, Chainmain_Supply_V1_SupplyResponse> {
    return self.makeUnaryCall(
      path: "/chainmain.supply.v1.Query/TotalSupply",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeTotalSupplyInterceptors() ?? []
    )
  }

  /// LiquidSupply queries the liquid supply of all coins.
  ///
  /// - Parameters:
  ///   - request: Request to send to LiquidSupply.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func liquidSupply(
    _ request: Chainmain_Supply_V1_SupplyRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Chainmain_Supply_V1_SupplyRequest, Chainmain_Supply_V1_SupplyResponse> {
    return self.makeUnaryCall(
      path: "/chainmain.supply.v1.Query/LiquidSupply",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeLiquidSupplyInterceptors() ?? []
    )
  }
}

internal protocol Chainmain_Supply_V1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'totalSupply'.
  func makeTotalSupplyInterceptors() -> [ClientInterceptor<Chainmain_Supply_V1_SupplyRequest, Chainmain_Supply_V1_SupplyResponse>]

  /// - Returns: Interceptors to use when invoking 'liquidSupply'.
  func makeLiquidSupplyInterceptors() -> [ClientInterceptor<Chainmain_Supply_V1_SupplyRequest, Chainmain_Supply_V1_SupplyResponse>]
}

internal final class Chainmain_Supply_V1_QueryClient: Chainmain_Supply_V1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Chainmain_Supply_V1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the chainmain.supply.v1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Chainmain_Supply_V1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query defines the gRPC querier service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Chainmain_Supply_V1_QueryProvider: CallHandlerProvider {
  var interceptors: Chainmain_Supply_V1_QueryServerInterceptorFactoryProtocol? { get }

  /// TotalSupply queries the total supply of all coins.
  func totalSupply(request: Chainmain_Supply_V1_SupplyRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Chainmain_Supply_V1_SupplyResponse>

  /// LiquidSupply queries the liquid supply of all coins.
  func liquidSupply(request: Chainmain_Supply_V1_SupplyRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Chainmain_Supply_V1_SupplyResponse>
}

extension Chainmain_Supply_V1_QueryProvider {
  internal var serviceName: Substring { return "chainmain.supply.v1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "TotalSupply":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Chainmain_Supply_V1_SupplyRequest>(),
        responseSerializer: ProtobufSerializer<Chainmain_Supply_V1_SupplyResponse>(),
        interceptors: self.interceptors?.makeTotalSupplyInterceptors() ?? [],
        userFunction: self.totalSupply(request:context:)
      )

    case "LiquidSupply":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Chainmain_Supply_V1_SupplyRequest>(),
        responseSerializer: ProtobufSerializer<Chainmain_Supply_V1_SupplyResponse>(),
        interceptors: self.interceptors?.makeLiquidSupplyInterceptors() ?? [],
        userFunction: self.liquidSupply(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Chainmain_Supply_V1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'totalSupply'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeTotalSupplyInterceptors() -> [ServerInterceptor<Chainmain_Supply_V1_SupplyRequest, Chainmain_Supply_V1_SupplyResponse>]

  /// - Returns: Interceptors to use when handling 'liquidSupply'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeLiquidSupplyInterceptors() -> [ServerInterceptor<Chainmain_Supply_V1_SupplyRequest, Chainmain_Supply_V1_SupplyResponse>]
}
