//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: kava/committee/v1beta1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the committee Msg service
///
/// Usage: instantiate `Kava_Committee_V1beta1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Kava_Committee_V1beta1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Kava_Committee_V1beta1_MsgClientInterceptorFactoryProtocol? { get }

  func submitProposal(
    _ request: Kava_Committee_V1beta1_MsgSubmitProposal,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Committee_V1beta1_MsgSubmitProposal, Kava_Committee_V1beta1_MsgSubmitProposalResponse>

  func vote(
    _ request: Kava_Committee_V1beta1_MsgVote,
    callOptions: CallOptions?
  ) -> UnaryCall<Kava_Committee_V1beta1_MsgVote, Kava_Committee_V1beta1_MsgVoteResponse>
}

extension Kava_Committee_V1beta1_MsgClientProtocol {
  internal var serviceName: String {
    return "kava.committee.v1beta1.Msg"
  }

  /// SubmitProposal defines a method for submitting a committee proposal
  ///
  /// - Parameters:
  ///   - request: Request to send to SubmitProposal.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func submitProposal(
    _ request: Kava_Committee_V1beta1_MsgSubmitProposal,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Committee_V1beta1_MsgSubmitProposal, Kava_Committee_V1beta1_MsgSubmitProposalResponse> {
    return self.makeUnaryCall(
      path: "/kava.committee.v1beta1.Msg/SubmitProposal",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeSubmitProposalInterceptors() ?? []
    )
  }

  /// Vote defines a method for voting on a proposal
  ///
  /// - Parameters:
  ///   - request: Request to send to Vote.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func vote(
    _ request: Kava_Committee_V1beta1_MsgVote,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Kava_Committee_V1beta1_MsgVote, Kava_Committee_V1beta1_MsgVoteResponse> {
    return self.makeUnaryCall(
      path: "/kava.committee.v1beta1.Msg/Vote",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeVoteInterceptors() ?? []
    )
  }
}

internal protocol Kava_Committee_V1beta1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'submitProposal'.
  func makeSubmitProposalInterceptors() -> [ClientInterceptor<Kava_Committee_V1beta1_MsgSubmitProposal, Kava_Committee_V1beta1_MsgSubmitProposalResponse>]

  /// - Returns: Interceptors to use when invoking 'vote'.
  func makeVoteInterceptors() -> [ClientInterceptor<Kava_Committee_V1beta1_MsgVote, Kava_Committee_V1beta1_MsgVoteResponse>]
}

internal final class Kava_Committee_V1beta1_MsgClient: Kava_Committee_V1beta1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Kava_Committee_V1beta1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the kava.committee.v1beta1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Kava_Committee_V1beta1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the committee Msg service
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Kava_Committee_V1beta1_MsgProvider: CallHandlerProvider {
  var interceptors: Kava_Committee_V1beta1_MsgServerInterceptorFactoryProtocol? { get }

  /// SubmitProposal defines a method for submitting a committee proposal
  func submitProposal(request: Kava_Committee_V1beta1_MsgSubmitProposal, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Committee_V1beta1_MsgSubmitProposalResponse>

  /// Vote defines a method for voting on a proposal
  func vote(request: Kava_Committee_V1beta1_MsgVote, context: StatusOnlyCallContext) -> EventLoopFuture<Kava_Committee_V1beta1_MsgVoteResponse>
}

extension Kava_Committee_V1beta1_MsgProvider {
  internal var serviceName: Substring { return "kava.committee.v1beta1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "SubmitProposal":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Committee_V1beta1_MsgSubmitProposal>(),
        responseSerializer: ProtobufSerializer<Kava_Committee_V1beta1_MsgSubmitProposalResponse>(),
        interceptors: self.interceptors?.makeSubmitProposalInterceptors() ?? [],
        userFunction: self.submitProposal(request:context:)
      )

    case "Vote":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Kava_Committee_V1beta1_MsgVote>(),
        responseSerializer: ProtobufSerializer<Kava_Committee_V1beta1_MsgVoteResponse>(),
        interceptors: self.interceptors?.makeVoteInterceptors() ?? [],
        userFunction: self.vote(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Kava_Committee_V1beta1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'submitProposal'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeSubmitProposalInterceptors() -> [ServerInterceptor<Kava_Committee_V1beta1_MsgSubmitProposal, Kava_Committee_V1beta1_MsgSubmitProposalResponse>]

  /// - Returns: Interceptors to use when handling 'vote'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeVoteInterceptors() -> [ServerInterceptor<Kava_Committee_V1beta1_MsgVote, Kava_Committee_V1beta1_MsgVoteResponse>]
}
